#!/bin/bash

# 判断是否为root用户
if [ "$(id -u)" != "0" ]; then
    echo "please run as root" 1>&2
    exit 1
fi

CONFIG_FILE=/etc/hosts
CONFIG_STRING_FLAG="# ====== kylin hosts ======"

# 如果已经配置，则移除
if grep -q "${CONFIG_STRING_FLAG}" ${CONFIG_FILE}; then
    start=$(cat -n ${CONFIG_FILE} | grep "${CONFIG_STRING_FLAG}" | awk 'NR==1' | awk '{print $1}')
    end=$(cat -n ${CONFIG_FILE} | grep "${CONFIG_STRING_FLAG}" | awk 'END {print}' | awk '{print $1}')
    if [[ $end -gt $start ]]; then
        # echo "$start -> $end"
        sed -i "${start},${end}d" ${CONFIG_FILE}
    fi
fi

cat >>${CONFIG_FILE} <<EOF
${CONFIG_STRING_FLAG}
172.20.191.209  gitlab2.kylin.com
#172.17.66.192   pm.kylin.com
172.17.50.104   pm.kylin.com
172.20.191.22   zsk.kylin.com
172.20.191.28   pki.kylin.com
172.20.191.29   oauth.kylin.com
172.20.191.3    distro.kylin.com
172.20.191.3    builder.kylin.com
172.20.191.4    launchpad.dev
172.20.191.4    dev.kylin.com
172.20.191.4    dev.kylinos.cn
172.20.191.4    keyserver.launchpad.dev
172.20.191.4    answers.launchpad.dev archive.launchpad.dev api.launchpad.dev bazaar.launchpad.dev bazaar-internal.launchpad.dev blueprints.launchpad.dev bugs.launchpad.dev code.launchpad.dev feeds.launchpad.dev lists.launchpad.dev ppa.launchpad.dev private-ppa.launchpad.dev translations.launchpad.dev xmlrpc-private.launchpad.dev xmlrpc.launchpad.dev launchpad.dev testopenid.dev
${CONFIG_STRING_FLAG}
EOF

cat -n ${CONFIG_FILE}
