# 本文件由源管理器管理，会定期检测与修复，请勿修改本文件
# deb http://archive.kylinos.cn/kylin/KYLIN-ALL 10.1 main universe multiverse restricted
# deb http://archive2.kylinos.cn/deb/kylin/production/PART-V10-SP1/custom/partner/V10-SP1 default all

# mount_overlay juniper-arm64
# mount_overlay kylin-amd64

function mount_overlay() {
    TARGET=$1
    mkdir -p ${TARGET}{-upper,-work,-merge}
    sudo mount -t overlay -o lowerdir=${TARGET},upperdir=${TARGET}-upper,workdir=${TARGET}-work overlay ${TARGET}-merge
    # sudo umount ${TARGET}-merge
}

# deb依赖
function deb_depends() {
    apt-cache depends --recurse --no-recommends --no-suggests --no-conflicts --no-breaks --no-replaces --no-enhances $1 | grep -v i386 | grep "^\w" | sort -u
}

# 下载deb
function down_deb() {
    deps=$(apt-cache depends --recurse --no-recommends --no-suggests --no-conflicts --no-breaks --no-replaces --no-enhances $1 | grep -v i386 | grep "^\w" | sort -u)
    apt-get download ${deps}
}

function down_test() {
    mkdir -p /var/tmp/debs
    cd /var/tmp/debs
    # 查看nginx依赖
    deb_depends nginx
    # 下载dfc
    down_deb dfc

    dpkg-scanpackages . | gzip -9c >Packages.gz

    # 备份sources.list文件
    if [ ! -f /etc/apt/sources.list.bak ]; then
        sudo cp /etc/apt/sources.list{,.bak}
    fi

    # 使用本地源
    echo "deb [trusted=yes] file:///var/tmp/debs/ ./" | sudo tee /etc/apt/sources.list
    sudo apt update
    sudo apt install dfc

    # 还原sources.list文件
    sudo cp /etc/apt/{sources.list.bak,sources.list}
}

# 获取安装好的系统deb包列表并下载
function down_all_debs() {
    ARCH=$(dpkg --print-architecture)
    CODENAME=$(lsb_release -c | awk '{print $2}')
    # RELEASE=$(lsb_release -r | awk '{print $2}')

    TARGET_DIR="${CODENAME}-${ARCH}"
    mkdir -p KYLINALL/${TARGET_DIR}
    cd KYLINALL/${TARGET_DIR}

    # deb包列表
    DEBS_LIST=debs.txt

    if [ ! -f "${DEBS_LIST}" ]; then
        dpkg -l | grep "^ii" | awk '{print $2}' >${DEBS_LIST}
        cp ${DEBS_LIST} ${DEBS_LIST}.origin
    fi

    for i in $(cat ${DEBS_LIST}); do
        if apt-cache madison $i | grep -q "/partner"; then
            # 不下载第三方合作源的deb包
            echo "partner: $i"
        else
            echo "apt download $i"
            apt download $i
            sed -i "/^${i}$/d" ${DEBS_LIST}
            # FilePath=$(sed -n '/Package: dkms$/,/^ /p' /var/lib/apt/lists/*_Packages | grep "^Filename:" | awk '{print $2}')
            # FileName=$(basename $FilePath)
            # FileMD5=$(md5sum ${FileName} | awk '{print $1}')
            # MD5sum=$(sed -n '/Package: dkms$/,/^ /p' /var/lib/apt/lists/*_Packages | grep "^MD5sum:" | awk '{print $2}')
            # if [ -f ${FileName} ]; then
            #     # 文件已经存在，md5错误，删除文件，重新下载
            #     if [ ${FileMD5} != ${MD5sum} ]; then
            #         rm ${FileName}
            #         apt download $i
            #     fi
            # else
            #     apt download $i
            # fi
        fi
    done
}
