# 使用 fakeroot 制作rootfs
ROOTFS_DIR=rootfs-fakeroot
MIRROR_URL="http://172.29.157.20/my_mirror/kylin"
fakechroot fakeroot debootstrap --no-check-gpg --variant=fakechroot --components=main,restricted,universe,multiverse v101 ${ROOTFS_DIR} ${MIRROR_URL} gutsy

# 无需root权限执行chroot
fakechroot fakeroot chroot ${ROOTFS_DIR}

# 解决提示groups不存在问题

## 方法1，使用unshare

: unshare，子进程与父进程隔离 <<!
-U: 取消共享用户名字空间
!

unshare -U fakechroot fakeroot chroot ${ROOTFS_DIR}

## 方法2，添加缺少的gid
function addgid() {
    # groups: 无法找到ID 为119 的用户的属组
    # groups: 无法找到ID 为129 的用户的属组
    # groups: 无法找到ID 为131 的用户的属组
    # groups: 无法找到ID 为1000 的用户的属组

    gs=($(id -G))
    gsn=($(id -Gn))
    echo "${gs[@]}, ${gsn[@]}"

    for ((i = 0; i < ${#gs[@]}; i++)); do
        echo groupadd -g ${gs[i]} ${gsn[i]}
        fakechroot fakeroot chroot ${ROOTFS_DIR} bash -c "awk -F: '{print \$3}' /etc/group | grep -q '^${gs[i]}$' || groupadd -g ${gs[i]} ${gsn[i]}"
    done
}
