#!/bin/bash
set -e

# ========== 源地址 ==========
function apt_my_mirror() {
    cat >/etc/apt/sources.list <<EOF
deb http://172.29.157.20/my_mirror/kylin v101 main
EOF
}

function apt_KYLIN_ALL() {
    cat >/etc/apt/sources.list <<EOF
deb http://archive.kylinos.cn/kylin/KYLIN-ALL 10.1 main universe multiverse restricted
EOF
}

function apt_local_KYLIN_ALL() {
    cat >/etc/apt/sources.list <<EOF
deb http://172.29.157.20/kylin/KYLIN-ALL 10.1 main restricted universe multiverse
EOF
}

function apt_launchpad() {
    cat >/etc/apt/sources.list <<EOF
deb http://archive.launchpad.dev/kylin v101 main multiverse restricted universe
deb http://archive.launchpad.dev/kylin-desktop v101 main multiverse restricted universe

deb-src http://archive.launchpad.dev/kylin v101 main multiverse restricted universe
deb-src http://archive.launchpad.dev/kylin-desktop v101 main multiverse restricted universe
EOF
}

function apt_local_launchpad() {
    cat >/etc/apt/sources.list <<EOF
deb http://172.29.157.20/launchpad/kylin v101 main multiverse restricted universe
deb http://172.29.157.20/launchpad/kylin-desktop v101 main multiverse restricted universe

deb-src http://172.29.157.20/launchpad/kylin v101 main multiverse restricted universe
deb-src http://172.29.157.20/launchpad/kylin-desktop v101 main multiverse restricted universe
EOF
}
# ========== 源地址 ==========

# 添加 用户
function create_user() {
    USERNAME="ekylin"
    PASSWORD="qwer1234"

    if ! awk -F: '{print $1}' /etc/passwd | grep -q ekylin; then
        useradd -m -s /bin/bash -u 2000 "${USERNAME}"
        usermod -c "${USERNAME}" "${USERNAME}"
        echo "${USERNAME}:${PASSWORD}" | chpasswd
        adduser ${USERNAME} sudo
        adduser ${USERNAME} adm
    else
        echo "user ${USERNAME} already exists"
    fi
}

export HOME=/root
export LC_ALL=C
export DEBIAN_FRONTEND=noninteractive

apt_my_mirror
apt update

apt install -y resize-assistant

### ==================== install packages ====================
# 制作过程中使用的源
apt_local_KYLIN_ALL
apt update

apt install -y dialog
apt install -y locales
apt install -y systemd-sysv
apt install -y tmux
### ==================== install packages ====================

### ==================== config system =======================
# 设置 hostname
echo kylinos >/etc/hostname

# 设置 root密码
echo root:qwer1234 | chpasswd
create_user

# 最终系统使用的源
apt_KYLIN_ALL

# 清理
rm -rf /var/cache/apt/archives/*.deb
rm -rf /var/cache/apt/*.bin
rm -rf /var/lib/apt/lists/*_Packages
rm -rf /var/lib/apt/lists/*_InRelease
rm -rf /root/.bash_history
rm -rf /tmp/*
rm -rf ~/.bash_history
### ==================== config system =======================

export HISTSIZE=0
exit
