#!/bin/bash
set -e

export HOME=/root
export LC_ALL=C

apt update
export DEBIAN_FRONTEND=noninteractive

apt install -y locales dialog
apt install -y openssh-server
apt install -y network-manager

# kdump
## v10 sp1
apt install -y linux-crashdump
## v10
# apt install -y kexec-tools kdump-tools

# grub相关包暂时先不用装
# apt install -y grub2-common
# 执行update-grub时，缺少: lsb-release,archdetect-deb
# apt install -y lsb-release archdetect-deb

# tools
apt install -y vim

# 审计相关
apt install -y auditd
apt install -y libpam-pwquality libpam-kysec

# ssh允许root登录
if [ -f /etc/ssh/sshd_config ]; then
    if [ ! -f /etc/ssh/sshd_config.bak ]; then
        cp /etc/ssh/sshd_config{,.bak}
    fi

    if ! grep -q "^PermitRootLogin yes$" /etc/ssh/sshd_config; then
        sed -i '/PermitRootLogin/d' /etc/ssh/sshd_config
        echo 'PermitRootLogin yes' >>/etc/ssh/sshd_config
    fi
fi

# Network Manager
if [ -d /etc/NetworkManager/conf.d ]; then
    touch /etc/NetworkManager/conf.d/10-globally-managed-devices.conf
fi

# 最终系统使用的源
cat >/etc/apt/sources.list <<EOF
deb http://archive.kylinos.cn/kylin/KYLIN-ALL 10.1 main universe multiverse restricted
EOF

# hostname
echo kylinos >/etc/hostname

# root密码
echo root:123456 | chpasswd

# 配置 kylin 用户
USERNAME="kylin"
PASSWORD="qwer1234"
useradd -m -s /bin/bash -u 1000 "${USERNAME}"
usermod -c "${USERNAME}" "${USERNAME}"
echo "${USERNAME}:${PASSWORD}" | chpasswd
adduser ${USERNAME} sudo
adduser ${USERNAME} adm

# 清理
rm -rf /var/cache/apt/archives/*.deb
rm -rf /var/cache/apt/*.bin
rm -rf /var/lib/apt/lists/*_Packages
rm -rf /var/lib/apt/lists/*_InRelease
rm -rf /root/.bash_history
rm -rf /tmp/*
rm -rf ~/.bash_history

export HISTSIZE=0
exit
