#!/bin/bash
set -e

export HOME=/root
export LC_ALL=C

apt update
apt install -y locales dialog
apt install -y openssh-server
apt install -y network-manager
# kernel dump
# apt install -y linux-crashdump
# 执行update-grub时，缺少: lsb-release,archdetect-deb
# apt install -y grub2-common lsb-release archdetect-deb

# ssh允许root登录
if [ -f /etc/ssh/sshd_config ]; then
    if [ ! -f /etc/ssh/sshd_config.bak ]; then
        cp /etc/ssh/sshd_config{,.bak}
    fi

    if ! grep -q "^PermitRootLogin yes$" /etc/ssh/sshd_config; then
        sed -i '/PermitRootLogin/d' /etc/ssh/sshd_config
        echo 'PermitRootLogin yes' >>/etc/ssh/sshd_config
    fi
fi

# hostname
echo kylinos >/etc/hostname

# Network Manager
if [ -d /etc/NetworkManager/conf.d ]; then
    touch /etc/NetworkManager/conf.d/10-globally-managed-devices.conf
fi

# 最终系统使用的源
cat >/etc/apt/sources.list <<EOF
deb http://archive.kylinos.cn/kylin/KYLIN-ALL 10.1 main universe multiverse restricted
EOF

# hostname
echo kylinos >/etc/hostname

# root密码
echo root:123456 | chpasswd

# 清理
rm -rf /var/cache/apt/archives/*.deb
rm -rf /var/cache/apt/*.bin
rm -rf /var/lib/apt/lists/*_Packages
rm -rf /var/lib/apt/lists/*_InRelease
rm -rf /root/.bash_history
rm -rf /tmp/*
rm -rf ~/.bash_history

export HISTSIZE=0
exit
