#!/bin/bash
set -e

export HOME=/root
export LC_ALL=C
export DEBIAN_FRONTEND=noninteractive

apt update
apt install -y systemd-sysv
apt install -y tmux vim
apt install -y linux-generic

# 网络工具
apt install -y openssh-server network-manager netplan.io iputils-ping iproute2 net-tools
# 常用工具
apt install -y vim file cpio lsof fdisk parted bash-completion

### ==================== config system =======================
# ssh允许root登录
if [ -f /etc/ssh/sshd_config ]; then
    if [ ! -f /etc/ssh/sshd_config.bak ]; then
        cp /etc/ssh/sshd_config{,.bak}
    fi

    if ! grep -q "^PermitRootLogin yes$" /etc/ssh/sshd_config; then
        sed -i '/PermitRootLogin/d' /etc/ssh/sshd_config
        echo 'PermitRootLogin yes' >>/etc/ssh/sshd_config
    fi
fi

# Network Manager
if [ -d /etc/NetworkManager/conf.d ]; then
    touch /etc/NetworkManager/conf.d/10-globally-managed-devices.conf
fi

# 设置 hostname
echo myubuntu >/etc/hostname

# 设置 root密码
echo root:qwer1234 | chpasswd

# 清理
rm -rf /var/cache/apt/archives/*.deb
rm -rf /var/cache/apt/*.bin
rm -rf /var/lib/apt/lists/*_Packages
rm -rf /var/lib/apt/lists/*_InRelease
rm -rf /root/.bash_history
rm -rf /tmp/*
rm -rf ~/.bash_history
### ==================== config system =======================

export HISTSIZE=0
exit
