# 研究 iso 制作

- 参考 [live-custom-ubuntu-from-scratch](https://github.com/mvallim/live-custom-ubuntu-from-scratch.git)

# 目前 casper 包报依赖问题

> 解决办法：改为 launchpad 源

```shell
# apt install cifs-utils
# Reading package lists... Done
# Building dependency tree
# Reading state information... Done
# Some packages could not be installed. This may mean that you have
# requested an impossible situation or if you are using the unstable
# distribution that some required packages have not yet been created
# or been moved out of Incoming.
# The following information may help to resolve the situation:

# The following packages have unmet dependencies:
#  cifs-utils : Depends: libwbclient0 (>= 2:4.0.3+dfsg1) but it is not going to be installed
# E: Unable to correct problems, you have held broken packages.

# apt install libwbclient0
# Reading package lists... Done
# Building dependency tree
# Reading state information... Done
# Some packages could not be installed. This may mean that you have
# requested an impossible situation or if you are using the unstable
# distribution that some required packages have not yet been created
# or been moved out of Incoming.
# The following information may help to resolve the situation:

# The following packages have unmet dependencies:
#  libwbclient0 : Depends: libtevent0 (>= 0.10.2~) but it is not going to be installed
# E: Unable to correct problems, you have held broken packages.

# apt install libtevent0，这个倒是能装上
```

# 内核 linux-generic 出错

> 解决问题，需要安装 fdisk

```shell
# 安装
root@lenovo:/boot# apt install -y --no-install-recommends linux-generic
Reading package lists... Done
Building dependency tree
Reading state information... Done
linux-generic is already the newest version (5.4.18.57.46).
0 upgraded, 0 newly installed, 0 to remove and 54 not upgraded.
1 not fully installed or removed.
After this operation, 0 B of additional disk space will be used.
Setting up linux-image-5.4.18-57-generic (5.4.18-57.46) ...
Processing triggers for linux-image-5.4.18-57-generic (5.4.18-57.46) ...
/etc/kernel/postinst.d/initramfs-tools:
update-initramfs: Generating /boot/initrd.img-5.4.18-57-generic
system arch x86_64
other add modules@
E: /usr/share/initramfs-tools/hooks/casper failed with return 1.
update-initramfs: failed for /boot/initrd.img-5.4.18-57-generic with 1.
run-parts: /etc/kernel/postinst.d/initramfs-tools exited with return code 1
dpkg: error processing package linux-image-5.4.18-57-generic (--configure):
 installed linux-image-5.4.18-57-generic package post-installation script subprocess returned error exit status 1
Errors were encountered while processing:
 linux-image-5.4.18-57-generic
E: Sub-process /usr/bin/dpkg returned an error code (1)

# 配置
version=5.4.18-57-generic
image_path=/boot/vmlinuz-$version
change=install

linux-update-symlinks $change $version $image_path

mkdir -p /usr/lib/linux/triggers

    cat - >/usr/lib/linux/triggers/$version <<EOF
DEB_MAINT_PARAMS="$*" run-parts --report --exit-on-error --arg=$version \
      --arg=$image_path /etc/kernel/postinst.d
EOF
    dpkg-trigger --no-await linux-update-$version

sh /usr/lib/linux/triggers/$version

bootdir=$(dirname "$2")
bootdir="/boot"
bootopt="-b ${bootdir}"
INITRAMFS_TOOLS_KERNEL_HOOK=1 update-initramfs -c -k "${version}" ${bootopt} >&2

. /usr/share/initramfs-tools/hook-functions
root@lenovo:/tmp# auto_add_modules net
system arch x86_64
other add modules@

version=$(uname -r)
mkinitramfs -v -o init.new "${version}"
mkinitramfs -v -o init.new "${version}" >log.txt 2>&1
```

4. Graphical installer

```shell
# 中间出现的配置
Setting up keyboard-configuration (1.194kylin3) ...
Your console font configuration will be updated the next time your system
boots. If you want to update it now, run 'setupcon' from a virtual console.
update-initramfs: deferring update (trigger activated)
```

5. Install window manager

```shell
apt install -y ukui-desktop-environment

...
Get:516 http://archive.launchpad.dev/kylin-desktop v101-updates/main amd64 ubuntukylin-wallpapers-focal all 20.04.16 [124 MB]
...

Unpacking ukui-input-gather (1.0.0-1+1201) ...
Selecting previously unselected package ukui-kwin-data.
Preparing to unpack .../430-ukui-kwin-data_1.0.1kylin60_all.deb ...
Unpacking ukui-kwin-data (1.0.1kylin60) ...
Selecting previously unselected package libxcb-cursor0:amd64.
Preparing to unpack .../431-libxcb-cursor0_0.1.1-4kylin1_amd64.deb ...
Unpacking libxcb-cursor0:amd64 (0.1.1-4kylin1) ...
Selecting previously unselected package ukui-kwin-common.
Preparing to unpack .../432-ukui-kwin-common_1.0.1kylin60_amd64.deb ...
Unpacking ukui-kwin-common (1.0.1kylin60) ...
Selecting previously unselected package ukui-kwin-x11.
Preparing to unpack .../433-ukui-kwin-x11_1.0.1kylin60_amd64.deb ...
Unpacking ukui-kwin-x11 (1.0.1kylin60) ...
Selecting previously unselected package ukui-kwin.
Preparing to unpack .../434-ukui-kwin_1.0.1kylin60_all.deb ...
Unpacking ukui-kwin (1.0.1kylin60) ...
Selecting previously unselected package ukui-power-manager.
Preparing to unpack .../435-ukui-power-manager_3.1.1-3_amd64.deb ...
Unpacking ukui-power-manager (3.1.1-3) ...
Selecting previously unselected package ukui-screensaver.
Preparing to unpack .../436-ukui-screensaver_3.1.1-34_amd64.deb ...
Unpacking ukui-screensaver (3.1.1-34) ...
Selecting previously unselected package vdpau-driver-all:amd64.
Preparing to unpack .../437-vdpau-driver-all_1.3-1kylin2_amd64.deb ...
Unpacking vdpau-driver-all:amd64 (1.3-1kylin2) ...
Selecting previously unselected package zip.
Preparing to unpack .../438-zip_3.0-11build1_amd64.deb ...
Unpacking zip (3.0-11build1) ...
Errors were encountered while processing:
 /tmp/apt-dpkg-install-SsCkEO/172-ukui-media_3.1.0-2022+0310_amd64.deb
 /tmp/apt-dpkg-install-SsCkEO/216-libkysset_1.1kord-24_amd64.deb
 /tmp/apt-dpkg-install-SsCkEO/218-kylin-system-updater_1.4.23kord_amd64.deb
 /tmp/apt-dpkg-install-SsCkEO/304-miraclecast_1.0.37.15kord_amd64.deb
 /tmp/apt-dpkg-install-SsCkEO/307-kylin-nm_3.1.1-2022+0317_amd64.deb
Error: GDBus.Error:org.freedesktop.DBus.Error.ServiceUnknown: The name org.freedesktop.PackageKit was not provided by any .service files
E: Sub-process /usr/bin/dpkg returned an error code (1)


root@lenovo:/etc/apt# apt install -y ukui-desktop-environment
Reading package lists... Done
Building dependency tree
Reading state information... Done
ukui-desktop-environment is already the newest version (2.0.3-1).
You might want to run 'apt --fix-broken install' to correct these.
The following packages have unmet dependencies:
 ukui-control-center : Depends: kylin-nm (>= 3.1.1-2021+1029.1) but it is not going to be installed
                       Depends: ukui-media (>= 3.0.0-64) but it is not going to be installed
                       Depends: libkysset (>= 1.1kord-14) but it is not going to be installed
                       Depends: kylin-system-updater (>= 1.2.1kord) but it is not going to be installed
                       Depends: miraclecast (>= 1.0.21kord) but it is not going to be installed
E: Unmet dependencies. Try 'apt --fix-broken install' with no packages (or specify a solution).
```

# 一些记录

```shell
# 登录相关
- ukui-greeter

# Error: GDBus.Error:org.freedesktop.DBus.Error.ServiceUnknown: The name org.freedesktop.PackageKit was not provided by any .service files
> PackageKit，包管理服务，通过 DBus 接口，执行某些简单的包管理任务，比如刷新缓存，安装、更新、移除软件等等。但是该服务经常占用大量 CPU 资源，非常多。可移除。

systemctl stop packagekit.service
systemctl disable packagekit.service

apt purge -y packagekit

# 轻量级浏览器
apt install -y midori

```

# v10 版本

```shell
symbol lookup error: /lib/aarch64-linux-gnu/libkysecwhlist.so.0.0.0: undefined symbol: path_is_exist

dpkg -S /lib/aarch64-linux-gnu/libkysecwhlist.so.0.0.0
libkysecwhlist:arm64: /lib/aarch64-linux-gnu/libkysecwhlist.so.0.0.0
```

# docker中运行rootfs-kylin

```
apt install -y dpkg-dev
```
