function test() {
    # I: usage: [OPTION]... <suite> <target> [<mirror> [<script>]]
    OPTIONS="--no-check-gpg --print-debs --keep-debootstrap-dir --variant=minbase --components=main,restricted,universe,multiverse"
    OPTIONS="--no-check-gpg --components=main,restricted,universe,multiverse"
    SUITE="v101"
    TARGET="/data/temp/kylin-rootfs"
    MIRROR="http://172.29.157.20/kylin/"
    sudo debootstrap ${OPTIONS} ${SUITE} ${TARGET} ${MIRROR}
}

# 分段执行arm
function test_arm1() {
    # 安装依赖包
    sudo apt-get install qemu-user-static
    sudo apt-get install binfmt-support debootstrap qemu

    sudo mkdir /opt/ubuntu-arm-64
    sudo debootstrap --arch=arm64 --foreign trusty /opt/ubuntu-arm-64 http://ports.ubuntu.com/
    sudo cp /usr/bin/qemu-aarch64-static /opt/ubuntu-arm-64/usr/bin/

    # 为第二阶段准备，挂载设备节点
    function ch_mount() {
        sudo mount -t proc proc proc/
        sudo mount -t sysfs sys sys/
        sudo mount -o bind /dev dev/
        sudo mount -t devpts pts dev/pts/
    }

    # --second-stage
    sudo chroot /opt/ubuntu-arm-64 /debootstrap/debootstrap --second-stage

    # 做完第二阶段，卸载设备节点
    function ch_umount() {
        sudo umount proc/
        sudo umount sys/
        sudo umount dev/
        sudo umount dev/pts/
    }
}

## 分段执行 实验研究
function test_kylin() {
    cd /data/temp/

    # 拷贝第1阶段到kylin-rootfs
    # sudo cp -rf 03-kylin-rootfs-first_stage_install/ kylin-rootfs
    sudo cp -rf 03-kylin-rootfs-first_stage_install-minimal kylin-rootfs

    # 拷贝第2阶段测试脚本
    sudo cp /data/git/gogs/kylin/debootstrap/my_debootstrap.sh /data/temp/kylin-rootfs/debootstrap/

    sudo chroot kylin-rootfs
    source /debootstrap/my_debootstrap.sh

    # sudo mkdir -p kylin-rootfs/data
    # sudo mount --bind shell_test/ kylin-rootfs/data/
    # cd kylin-rootfs
    # ch_mount
    # cd ..

    # sudo chroot kylin-rootfs
    # source /data/my_debootstrap.sh
    # ch_umount
}

########## my_rootfs ##########
# 从系统拷贝文件
copy_from_sys() {
    pp=$(dirname $1)
    mkdir -p ".${pp}"
    cp -v $1 ".${pp}"
}

# 拷贝可执行程序
function copy_exec_file() {
    FILE=$1
    copy_from_sys $FILE

    # lib64
    for i in $(ldd ${FILE} | grep "lib64" | awk '{print $1}'); do
        copy_from_sys $i
        realfile=$(readlink -f "${i}")
        copy_from_sys ${realfile}
    done

    # lib
    for i in $(ldd ${FILE} | grep "=>" | awk '{print $3}'); do
        copy_from_sys $i
        realfile=$(readlink -f "${i}")
        copy_from_sys ${realfile}
    done
}

# 创建必要的目录
function my_rootfs() {
    mkdir -p usr/{bin,sbin,lib,lib32,lib64,libx32}

    ln -s usr/bin .
    ln -s usr/lib .
    ln -s usr/lib32 .
    ln -s usr/lib64 .
    ln -s usr/libx32 .
    ln -s usr/sbin .

    mkdir -p boot dev etc home mnt opt proc root run tmp var
}

# my_rootfs

# 拷贝必要的文件
# copy_exec_file /bin/bash
# copy_exec_file /bin/ls
# copy_from_sys /bin/busybox
