function usage() {
    echo -e "USAGE:\n\
    $(basename $0) KYLIN-ALL.list        # 使用 kylin v10 sp1 桌面 源\n\
    $(basename $0) local.KYLIN-ALL.list  # 使用本地镜像 kylin v10 sp1 桌面源\n\
    $(basename $0) launchpad.list        # 使用 launchpad.dev 源\n\
    $(basename $0) local.launchpad.list  # 使用 lcoal.launchpad.dev 源\n\
    "

    exit 1
}

# 判断参数个数
if [ $# -eq 0 ]; then
    usage
    exit 1
fi

if [ -f $1 ]; then
    # 替换系统默认模板文件，不好使。禁止系统服务方式好使
    # sudo cp $1 /var/lib/kylin-software-properties/template/kylin-source-template-main.list

    # 禁止 修改软件源 的系统服务
    services=$(systemctl list-unit-files | grep "kylin-so" | awk '{if($2=="enabled") {print $1} }')
    [ -n "${services}" ] && sudo systemctl disable ${services}

    # 启用 修改软件源 的系统服务
    # services=$(systemctl list-unit-files | grep "kylin-so" | awk '{if($2=="disabled") {print $1} }')
    # [ -n "${services}" ] && sudo systemctl enable ${services}

    # 备份源文件
    sudo cp /etc/apt/sources.list{,.bak}

    # 使用指定的源文件
    sudo cp $1 /etc/apt/sources.list

    sudo apt update
else
    echo "$1 is not exist!!"
fi
