#!/bin/bash

# 判断是否为root用户
if [ "$(id -u)" != "0" ]; then
    echo "please run as root" 1>&2
    exit 1
fi

# 以root权限执行
# [ -f /usr/share/ca-certificates/KY-WEB.crt ] || wget -q http://pki.kylin.com/ca/KY-WEB.crt -O /usr/share/ca-certificates/KY-WEB.crt
# [ -f /usr/share/ca-certificates/KY-CA.crt ] || wget -q http://pki.kylin.com/ca/KY-CA.crt -O /usr/share/ca-certificates/KY-CA.crt

sudo cp KY-WEB.crt /usr/share/ca-certificates/KY-WEB.crt
sudo cp KY-CA.crt /usr/share/ca-certificates/KY-CA.crt

CONFIG_FILE=/etc/ca-certificates.conf
CONFIG_STRING_FLAG="# ====== kylin certs ======"

# 如果已经配置，则移除
if grep -q "${CONFIG_STRING_FLAG}" ${CONFIG_FILE}; then
    start=$(cat -n ${CONFIG_FILE} | grep "${CONFIG_STRING_FLAG}" | awk 'NR==1' | awk '{print $1}')
    end=$(cat -n ${CONFIG_FILE} | grep "${CONFIG_STRING_FLAG}" | awk 'END {print}' | awk '{print $1}')
    if [[ $end -gt $start ]]; then
        # echo "$start -> $end"
        sed -i "${start},${end}d" ${CONFIG_FILE}
    fi
fi

# 导入launchpad的CA证书
cat >>${CONFIG_FILE} <<EOF
${CONFIG_STRING_FLAG}
KY-WEB.crt
KY-CA.crt
${CONFIG_STRING_FLAG}
EOF

update-ca-certificates
