#!/bin/bash

function usage() {
    echo "USAGE:
    $(basename $0) /path/filename.wic.tar.gz /dev/xxx

Example:
    $(basename $0) kylinos-image-openbox-qemuarm64.rootfs.wic.tar.gz /dev/nvme0n1
    "
    exit 1
}

# 判断是否为root用户
if [ "$(id -u)" != "0" ]; then
    echo "please run as root" 1>&2
    exit 1
fi

# 判断参数个数
if [ ! $# -eq 2 ]; then
    usage
fi

if [ -f "$1" ]; then
    if [ -b "$2" ]; then
        tar xvf "$1" -O | dd of=$2 status=progress
    else
        echo "block $2 not exist!"
    fi
else
    echo "$1 not exist!"
fi
